# -*- coding: utf-8 -*-
# Importations des modules
import string
import re

# Fonction de récupération des "n" mots autour d'un terme recherché (de façon exacte ou non)
def generateWrapText(text = "", search = "", limit = 10, exactMatch = False, removedPunct = "'-", splitChars = " ", prev = "(...)", next = "..."):
    if text != "":
        # Récupération et nettoyage de la ponctuation globale
        punctuations = string.punctuation
        punctuations = re.sub("["+removedPunct+"]", "", punctuations)

        # Regex de base
        regex = "["+splitChars+"]"

        # Teste la requête (pour savoir si elle contient un ou plusieurs mots)
        words = search.split()
        if len(words) > 1:
            if search[-1] == "*":
                s = search[:-1]
            elif search[0] == "*":
                s = search[1:]
            elif search[0] == "*" and search[-1] == "*":
                s = search[1:-1]
            else:
                s = search
            # Regex réadapté si plusieurs mots composent la recherche (recherche d'une chaîne entre guillemets)
            regex = "(["+splitChars+"]|"+s+"[^"+splitChars+"]*)"

        # Découpe la phrase en mots pour trouver les occurrences de la recherche
        wordsFromSentence = list(filter(str.strip, re.split(regex, text, flags=re.IGNORECASE)))

        # Récupère l'ensemble des occurrences de la recherche dans le texte
        # occurrences = [n for n,item in enumerate(wordsFromSentence) if item == search]

        # Liste des phrases à récupérer
        sentences = []

        # Parcours de l'ensemble des mots du texte
        for index, word in enumerate(wordsFromSentence):
            # Paramètres par défaut
            isStart = False
            isEnd = False
            createdString = ""
            finalString = ""
            createSequence = False

            # # Si le mot recherché n'est pas trouvé, on continue
            # if exactMatch == True or (search[0] != "*" and search[-1] != "*"):
            #     if search[-1] == "*":
            #         if not re.search("^"+search[:-1], word, flags=re.IGNORECASE):
            #             continue
            #     elif search[0] == "*":
            #         if not re.search(search[1:]+"$", word, flags=re.IGNORECASE):
            #             continue
            #     else:
            #         if not re.search("^"+search+"$", word, flags=re.IGNORECASE):
            #             continue
            # else:
            #     if search[-1] == "*" and search[0] != "*":
            #         search = search[:-1]
            #     elif search[0] == "*" and search[-1] != "*":
            #         search = search[1:]
            #     elif search[0] == "*" and search[-1] == "*":
            #         search = search[1:-1]
                
            #     if not re.search(search, re.sub("["+punctuations+"]", "", word), flags=re.IGNORECASE):
            #         continue

            # Si le mot recherché n'est pas trouvé, on continue
            if exactMatch == True:
                if search[-1] == "*" and search[0] != "*":
                    if re.search("^"+search[:-1], re.sub("["+punctuations+"]", "", word), flags=re.IGNORECASE):
                        createSequence = True
                elif search[0] == "*" and search[-1] != "*":
                    if re.search(search[1:]+"$", re.sub("["+punctuations+"]", "", word), flags=re.IGNORECASE):
                        createSequence = True
                elif search[0] == "*" and search[-1] == "*":
                    if re.search(search[1:-1], re.sub("["+punctuations+"]", "", word), flags=re.IGNORECASE):
                        createSequence = True
                else:
                    if re.search("^"+search+"$", re.sub("["+punctuations+"]", "", word), flags=re.IGNORECASE):
                        createSequence = True
            else:
                if search[-1] == "*" and search[0] != "*":
                    search = search[:-1]
                elif search[0] == "*" and search[-1] != "*":
                    search = search[1:]
                elif search[0] == "*" and search[-1] == "*":
                    search = search[1:-1]

                if re.search(search, word, flags=re.IGNORECASE):
                    createSequence = True

            # Si une séquence doit être créée
            if createSequence == True:
                # "n" mots précédents
                for i in range(limit, 0, -1):
                    posMotPrecedent = index - i
                    if posMotPrecedent >= 0 and wordsFromSentence[posMotPrecedent]:
                        createdString = createdString + " " + wordsFromSentence[posMotPrecedent]
                    else:
                        isStart = True

                # Mot recherché
                createdString = createdString + " " + wordsFromSentence[index]

                # "n" mots suivants
                isOK = False
                for i in range(1, limit + 1, 1):
                    posMotSuivant = index + i

                    if posMotSuivant < len(wordsFromSentence) and wordsFromSentence[posMotSuivant]:
                        createdString = createdString + " " + wordsFromSentence[posMotSuivant]
                    else:
                        isEnd = True

                # Ajout des caractères de début (... par exemple) si le découpage n'atteint pas le début du texte.
                if isStart == False:
                    finalString = finalString + prev

                # Ajout de la chaîne reconstituée
                finalString = finalString + createdString
                
                # Ajout des caractères de fin (... par exemple) si la phrase n'est pas au bout.
                if isEnd == False:
                    finalString = finalString + next

                # Ajout de l'occurrence et des mots environnants dans une liste
                sentences.append(finalString.strip())

        return sentences