import string
import re

def generateWrapText(text, search = "", limit = 10, exactMatch = False, removedPunct = "'-", splitChars = " ", prev = "(...) ", next = "..."):
    if text != "" and search != "":
        # Récupération et nettoyage de la ponctuation globale
        punctuations = string.punctuation
        punctuations = re.sub("["+removedPunct+"]", "", punctuations)

        # Gestion des requêtes étoilées
        search = re.sub("([\\*](\s|\"|$))", r".\1", search)
        search = re.sub("((\s|\"|^)[\\*])", r".\1", search)

        # Gestion de la requête recherchée (requête étoilée, expression de plusieurs mots...)
        regex = "["+splitChars+"]" # Regex de base
        query_splitted = list(filter(str.strip, re.split(regex, search, flags=re.IGNORECASE)))
        query_splitted_nb = len(query_splitted)

        # Découpe la phrase en mots pour trouver les occurrences de la recherche
        split = re.split(regex, text, flags=re.IGNORECASE) # Découpe à chaque espace
        wordsFromSentence = list(filter(str.strip, split))
        wordsForSequences = list(re.sub("["+punctuations+"\n\t\r]+", "", w) for w in wordsFromSentence)

        # Récupère la liste des index pour chaque occurrence du mot recherché
        regex_search = "^"+search+"$" if exactMatch == True else search
        if query_splitted_nb == 1:
            indexes = [(i,i+1) for i, x in enumerate(wordsForSequences) if re.match(regex_search, x, flags=re.IGNORECASE)]
        else:
            indexes = [(i,i+query_splitted_nb) for i, x in enumerate(wordsForSequences) if re.match(regex_search, " ".join(wordsForSequences[i:i+query_splitted_nb]), flags=re.IGNORECASE)]

        # Liste des phrases à récupérer
        sentences = []

        for found_index in indexes:
            index_start = max(found_index[0] - limit, 0) # Index du premier mot de la requête
            index_end = max(found_index[1] + limit, 0) # Index du dernier mot de la requête

            sentence = " ".join(wordsFromSentence[index_start:index_end]) # Création des séquences de mots autour de la requête
            if index_start < limit:
                sentence = prev + sentence # Ajoute le préfixe si nécessaire
            if (index_end + limit) > len(wordsForSequences):
                sentence = sentence + next # Ajoute le suffixe si nécessaire
            sentences.append(sentence) # Ajoute la séquence dans la liste des phrases retenues

        return sentences